
# makefile for panorama stitching, created by hugin using the new makefilelib

# Tool configuration
NONA=nona
PTSTITCHER=PTStitcher
PTMENDER=PTmender
PTBLENDER=PTblender
PTMASKER=PTmasker
PTROLLER=PTroller
ENBLEND=/usr/local/bin/multiblend
ENFUSE=enfuse
SMARTBLEND=smartblend.exe
HDRMERGE=hugin_hdrmerge
RM=rm
EXIFTOOL=exiftool

# Project parameters
HUGIN_PROJECTION=2
HUGIN_HFOV=34
HUGIN_WIDTH=3000
HUGIN_HEIGHT=3529

# options for the programs
NONA_LDR_REMAPPED_COMP=-z LZW
NONA_OPTS=
ENBLEND_OPTS=-a -v -f2946x2506+40+23
ENBLEND_LDR_COMP=--compression=LZW
ENBLEND_EXPOSURE_COMP=--compression=LZW
ENBLEND_HDR_COMP=
HDRMERGE_OPTS=-m avg -c
ENFUSE_OPTS=-v
EXIFTOOL_COPY_ARGS=-ImageDescription -Make -Model -Artist -WhitePoint -Copyright -GPS:all -DateTimeOriginal -CreateDate -UserComment -ColorSpace -OwnerName -SerialNumber
EXIFTOOL_INFO_ARGS='-Software=Hugin Pre-Release 2011.5.0.f1c1e4f56585' '-UserComment<$${UserComment}&\#xa;Projection: Equirectangular (2)&\#xa;FOV: 34 x 40&\#xa;Ev: 0.00' -f

# the output panorama
LDR_REMAPPED_PREFIX=1-2
LDR_REMAPPED_PREFIX_SHELL=1-2
HDR_STACK_REMAPPED_PREFIX=1-2_hdr_
HDR_STACK_REMAPPED_PREFIX_SHELL=1-2_hdr_
LDR_EXPOSURE_REMAPPED_PREFIX=1-2_exposure_layers_
LDR_EXPOSURE_REMAPPED_PREFIX_SHELL=1-2_exposure_layers_
PROJECT_FILE=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1-2.pto
PROJECT_FILE_SHELL=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1-2.pto
LDR_BLENDED=1-2.tif
LDR_BLENDED_SHELL=1-2.tif
LDR_STACKED_BLENDED=1-2_fused.tif
LDR_STACKED_BLENDED_SHELL=1-2_fused.tif
LDR_EXPOSURE_LAYERS_FUSED=1-2_blended_fused.tif
LDR_EXPOSURE_LAYERS_FUSED_SHELL=1-2_blended_fused.tif
HDR_BLENDED=1-2_hdr.exr
HDR_BLENDED_SHELL=1-2_hdr.exr

# first input image
INPUT_IMAGE_1=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg
INPUT_IMAGE_1_SHELL=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg

# all input images
INPUT_IMAGES=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg\
/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg
INPUT_IMAGES_SHELL=/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg\
/root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg

# remapped images
LDR_LAYERS=1-20000.tif\
1-20001.tif
LDR_LAYERS_SHELL=1-20000.tif\
1-20001.tif

# remapped images (hdr)
HDR_LAYERS=1-2_hdr_0000.exr\
1-2_hdr_0001.exr
HDR_LAYERS_SHELL=1-2_hdr_0000.exr\
1-2_hdr_0001.exr

# remapped maxval images
HDR_LAYERS_WEIGHTS=1-2_hdr_0000_gray.pgm\
1-2_hdr_0001_gray.pgm
HDR_LAYERS_WEIGHTS_SHELL=1-2_hdr_0000_gray.pgm\
1-2_hdr_0001_gray.pgm

# stacked hdr images
HDR_STACK_0=1-2_stack_hdr_0000.exr
HDR_STACK_0_SHELL=1-2_stack_hdr_0000.exr
HDR_STACK_0_INPUT=1-2_hdr_0000.exr
HDR_STACK_0_INPUT_SHELL=1-2_hdr_0000.exr
HDR_STACK_1=1-2_stack_hdr_0001.exr
HDR_STACK_1_SHELL=1-2_stack_hdr_0001.exr
HDR_STACK_1_INPUT=1-2_hdr_0001.exr
HDR_STACK_1_INPUT_SHELL=1-2_hdr_0001.exr
HDR_STACKS_NUMBERS=0 1 
HDR_STACKS=$(HDR_STACK_0) $(HDR_STACK_1) 
HDR_STACKS_SHELL=$(HDR_STACK_0_SHELL) $(HDR_STACK_1_SHELL) 

# number of image sets with similar exposure
LDR_EXPOSURE_LAYER_0=1-2_exposure_0000.tif
LDR_EXPOSURE_LAYER_0_SHELL=1-2_exposure_0000.tif
LDR_EXPOSURE_LAYER_0_INPUT=1-2_exposure_layers_0000.tif\
1-2_exposure_layers_0001.tif
LDR_EXPOSURE_LAYER_0_INPUT_SHELL=1-2_exposure_layers_0000.tif\
1-2_exposure_layers_0001.tif
LDR_EXPOSURE_LAYER_0_INPUT_PTMENDER=1-20000.tif\
1-20001.tif
LDR_EXPOSURE_LAYER_0_INPUT_PTMENDER_SHELL=1-20000.tif\
1-20001.tif
LDR_EXPOSURE_LAYER_0_EXPOSURE=0
LDR_EXPOSURE_LAYERS_NUMBERS=0 
LDR_EXPOSURE_LAYERS=$(LDR_EXPOSURE_LAYER_0) 
LDR_EXPOSURE_LAYERS_SHELL=$(LDR_EXPOSURE_LAYER_0_SHELL) 
LDR_EXPOSURE_LAYERS_REMAPPED=1-2_exposure_layers_0000.tif\
1-2_exposure_layers_0001.tif
LDR_EXPOSURE_LAYERS_REMAPPED_SHELL=1-2_exposure_layers_0000.tif\
1-2_exposure_layers_0001.tif

# stacked ldr images
LDR_STACK_0=1-2_stack_ldr_0000.tif
LDR_STACK_0_SHELL=1-2_stack_ldr_0000.tif
LDR_STACK_0_INPUT=1-2_exposure_layers_0000.tif
LDR_STACK_0_INPUT_SHELL=1-2_exposure_layers_0000.tif
LDR_STACK_1=1-2_stack_ldr_0001.tif
LDR_STACK_1_SHELL=1-2_stack_ldr_0001.tif
LDR_STACK_1_INPUT=1-2_exposure_layers_0001.tif
LDR_STACK_1_INPUT_SHELL=1-2_exposure_layers_0001.tif
LDR_STACKS_NUMBERS=0 1 
LDR_STACKS=$(LDR_STACK_0) $(LDR_STACK_1) 
LDR_STACKS_SHELL=$(LDR_STACK_0_SHELL) $(LDR_STACK_1_SHELL) 
DO_LDR_BLENDED=1

all : startStitching $(LDR_BLENDED) 

startStitching : 
	@echo '==========================================================================='
	@echo 'Stitching panorama'
	@echo '==========================================================================='

clean : 
	@echo '==========================================================================='
	@echo 'Remove temporary files'
	@echo '==========================================================================='
	-$(RM) $(LDR_LAYERS_SHELL) 

test : 
	@echo '==========================================================================='
	@echo 'Testing programs'
	@echo '==========================================================================='
	@echo -n 'Checking nona...'
	@-$(NONA) --help > /dev/null 2>&1 && echo '[OK]' || echo '[FAILED]'
	@echo -n 'Checking enblend...'
	@-$(ENBLEND) -h > /dev/null 2>&1 && echo '[OK]' || echo '[FAILED]'
	@echo -n 'Checking enfuse...'
	@-$(ENFUSE) -h > /dev/null 2>&1 && echo '[OK]' || echo '[FAILED]'
	@echo -n 'Checking hugin_hdrmerge...'
	@-$(HDRMERGE) -h > /dev/null 2>&1 && echo '[OK]' || echo '[FAILED]'
	@echo -n 'Checking exiftool...'
	@-$(EXIFTOOL) -ver > /dev/null 2>&1 && echo '[OK]' || echo '[FAILED]'

info : 
	@echo '==========================================================================='
	@echo '***************  Panorama makefile generated by Hugin       ***************'
	@echo '==========================================================================='
	@echo 'System information'
	@echo '==========================================================================='
	@echo -n 'Operating system: '
	@-uname -o
	@echo -n 'Release: '
	@-uname -r
	@echo -n 'Kernel version: '
	@-uname -v
	@echo -n 'Machine: '
	@-uname -m
	@echo 'Disc usage'
	@-df -h
	@echo 'Memory usage'
	@-free -m
	@echo '==========================================================================='
	@echo 'Output options'
	@echo '==========================================================================='
	@echo 'Hugin Version: Pre-Release 2011.5.0.f1c1e4f56585'
	@echo 'Project file: /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1-2.pto'
	@echo 'Output prefix: 1-2'
	@echo 'Projection: Equirectangular (2)'
	@echo 'Field of view: 34 x 40'
	@echo 'Canvas dimensions: 3000 x 3529'
	@echo 'Crop area: (40,23) - (2986,2529)'
	@echo 'Output exposure value: 0.00'
	@echo 'Selected outputs'
	@echo 'Normal panorama'
	@echo '* Blended panorama'
	@echo '==========================================================================='
	@echo 'Input images'
	@echo '==========================================================================='
	@echo 'Number of images in project file: 2'
	@echo 'Number of active images: 2'
	@echo 'Image 0: /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg'
	@echo 'Image 0: Size 960x1440, Exposure: 0.00'
	@echo 'Image 1: /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg'
	@echo 'Image 1: Size 960x1440, Exposure: 0.00'

# Rules for ordinary TIFF_m and hdr output

1-20000.tif : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) $(NONA_LDR_REMAPPED_COMP) -r ldr -m TIFF_m -o $(LDR_REMAPPED_PREFIX_SHELL) -i 0 $(PROJECT_FILE_SHELL)

1-2_hdr_0000.exr : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) -r hdr -m EXR_m -o $(HDR_STACK_REMAPPED_PREFIX_SHELL) -i 0 $(PROJECT_FILE_SHELL)

1-20001.tif : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) $(NONA_LDR_REMAPPED_COMP) -r ldr -m TIFF_m -o $(LDR_REMAPPED_PREFIX_SHELL) -i 1 $(PROJECT_FILE_SHELL)

1-2_hdr_0001.exr : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) -r hdr -m EXR_m -o $(HDR_STACK_REMAPPED_PREFIX_SHELL) -i 1 $(PROJECT_FILE_SHELL)

# Rules for exposure layer output

1-2_exposure_layers_0000.tif : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/1.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) $(NONA_LDR_REMAPPED_COMP) -r ldr -e 0 -m TIFF_m -o $(LDR_EXPOSURE_REMAPPED_PREFIX_SHELL) -i 0 $(PROJECT_FILE_SHELL)

1-2_exposure_layers_0001.tif : /root/wd/photos/ssd/dc_night_3_29_2012/museum/error_tests/2.jpg $(PROJECT_FILE) 
	$(NONA) $(NONA_OPTS) $(NONA_LDR_REMAPPED_COMP) -r ldr -e 0 -m TIFF_m -o $(LDR_EXPOSURE_REMAPPED_PREFIX_SHELL) -i 1 $(PROJECT_FILE_SHELL)

# Rules for LDR and HDR stack merging, a rule for each stack

$(LDR_STACK_0) : $(LDR_STACK_0_INPUT) 
	$(ENFUSE) $(ENFUSE_OPTS) -o $(LDR_STACK_0_SHELL) -- $(LDR_STACK_0_INPUT_SHELL)
	-$(EXIFTOOL) -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(LDR_STACK_0_SHELL)

$(HDR_STACK_0) : $(HDR_STACK_0_INPUT) 
	$(HDRMERGE) $(HDRMERGE_OPTS) -o $(HDR_STACK_0_SHELL) -- $(HDR_STACK_0_INPUT_SHELL)

$(LDR_STACK_1) : $(LDR_STACK_1_INPUT) 
	$(ENFUSE) $(ENFUSE_OPTS) -o $(LDR_STACK_1_SHELL) -- $(LDR_STACK_1_INPUT_SHELL)
	-$(EXIFTOOL) -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(LDR_STACK_1_SHELL)

$(HDR_STACK_1) : $(HDR_STACK_1_INPUT) 
	$(HDRMERGE) $(HDRMERGE_OPTS) -o $(HDR_STACK_1_SHELL) -- $(HDR_STACK_1_INPUT_SHELL)

$(LDR_BLENDED) : $(LDR_LAYERS) 
	$(ENBLEND) $(ENBLEND_LDR_COMP) $(ENBLEND_OPTS) -o $(LDR_BLENDED_SHELL) -- $(LDR_LAYERS_SHELL)
	-$(EXIFTOOL) -E -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(EXIFTOOL_INFO_ARGS) $(LDR_BLENDED_SHELL)

$(LDR_EXPOSURE_LAYER_0) : $(LDR_EXPOSURE_LAYER_0_INPUT) 
	$(ENBLEND) $(ENBLEND_EXPOSURE_COMP) $(ENBLEND_OPTS) -o $(LDR_EXPOSURE_LAYER_0_SHELL) -- $(LDR_EXPOSURE_LAYER_0_INPUT_SHELL)
	-$(EXIFTOOL) -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(LDR_EXPOSURE_LAYER_0_SHELL)

$(LDR_STACKED_BLENDED) : $(LDR_STACKS) 
	$(ENBLEND) $(ENBLEND_LDR_COMP) $(ENBLEND_OPTS) -o $(LDR_STACKED_BLENDED_SHELL) -- $(LDR_STACKS_SHELL)
	-$(EXIFTOOL) -E -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(EXIFTOOL_INFO_ARGS) $(LDR_STACKED_BLENDED_SHELL)

$(LDR_EXPOSURE_LAYERS_FUSED) : $(LDR_EXPOSURE_LAYERS) 
	$(ENFUSE) $(ENBLEND_LDR_COMP) $(ENFUSE_OPTS) -o $(LDR_EXPOSURE_LAYERS_FUSED_SHELL) -- $(LDR_EXPOSURE_LAYERS_SHELL)
	-$(EXIFTOOL) -E -overwrite_original_in_place -TagsFromFile $(INPUT_IMAGE_1_SHELL) $(EXIFTOOL_COPY_ARGS) $(EXIFTOOL_INFO_ARGS) $(LDR_EXPOSURE_LAYERS_FUSED_SHELL)

$(HDR_BLENDED) : $(HDR_STACKS) 
	$(ENBLEND) $(ENBLEND_HDR_COMP) $(ENBLEND_OPTS) -o $(HDR_BLENDED_SHELL) -- $(HDR_STACKS_SHELL)

$(LDR_REMAPPED_PREFIX)_multilayer.tif : $(LDR_LAYERS) 
	tiffcp $(LDR_LAYERS_SHELL) $(LDR_REMAPPED_PREFIX_SHELL)_multilayer.tif

$(LDR_REMAPPED_PREFIX)_fused_multilayer.tif : $(LDR_STACKS) $(LDR_EXPOSURE_LAYERS) 
	tiffcp $(LDR_STACKS_SHELL) $(LDR_EXPOSURE_LAYERS_SHELL) $(LDR_REMAPPED_PREFIX_SHELL)_fused_multilayer.tif

$(LDR_REMAPPED_PREFIX)_multilayer.psd : $(LDR_LAYERS) 
	PTtiff2psd -o $(LDR_REMAPPED_PREFIX_SHELL)_multilayer.psd $(LDR_LAYERS_SHELL)

$(LDR_REMAPPED_PREFIX)_fused_multilayer.psd : $(LDR_STACKS) $(LDR_EXPOSURE_LAYERS) 
	PTtiff2psd -o $(LDR_REMAPPED_PREFIX_SHELL)_fused_multilayer.psd $(LDR_STACKS_SHELL)$(LDR_EXPOSURE_LAYERS_SHELL)
